# sarus-proxy
No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.1.0
- Package version: 1.0.8
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import sarus_proxy
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import sarus_proxy
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import sarus_proxy
from sarus_proxy.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = sarus_proxy.Configuration(
    host = "http://localhost"
)



# Enter a context with an instance of the API client
with sarus_proxy.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = sarus_proxy.DefaultApi(api_client)

    try:
        # Redirect Auth
        api_response = api_instance.redirect_auth_dashboard_auth_get()
        print("The response of DefaultApi->redirect_auth_dashboard_auth_get:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling DefaultApi->redirect_auth_dashboard_auth_get: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**redirect_auth_dashboard_auth_get**](docs/DefaultApi.md#redirect_auth_dashboard_auth_get) | **GET** /dashboard/auth | Redirect Auth
*DefaultApi* | [**redirect_dashboard_dashboard_get**](docs/DefaultApi.md#redirect_dashboard_dashboard_get) | **GET** /dashboard | Redirect Dashboard
*DefaultApi* | [**redirect_events_dashboard_events_get**](docs/DefaultApi.md#redirect_events_dashboard_events_get) | **GET** /dashboard/events | Redirect Events
*EventsApi* | [**create_event_api_v1_events_post**](docs/EventsApi.md#create_event_api_v1_events_post) | **POST** /api/v1/events | Create Event
*EventsApi* | [**create_feedback_event_api_v1_feedbacks_event_id_get**](docs/EventsApi.md#create_feedback_event_api_v1_feedbacks_event_id_get) | **GET** /api/v1/feedbacks/{event_id} | Create Feedback Event
*EventsApi* | [**delete_event_api_v1_events_id_delete**](docs/EventsApi.md#delete_event_api_v1_events_id_delete) | **DELETE** /api/v1/events/{id} | Delete Event
*EventsApi* | [**get_feedback_events_api_v1_feedbacks_get**](docs/EventsApi.md#get_feedback_events_api_v1_feedbacks_get) | **GET** /api/v1/feedbacks | Get Feedback Events
*EventsApi* | [**read_event_api_v1_events_id_get**](docs/EventsApi.md#read_event_api_v1_events_id_get) | **GET** /api/v1/events/{id} | Read Event
*EventsApi* | [**read_events_api_v1_events_get**](docs/EventsApi.md#read_events_api_v1_events_get) | **GET** /api/v1/events | Read Events
*LoginApi* | [**login_access_token_api_v1_login_access_token_post**](docs/LoginApi.md#login_access_token_api_v1_login_access_token_post) | **POST** /api/v1/login/access-token | Login Access Token
*LoginApi* | [**recover_password_api_v1_password_recovery_email_post**](docs/LoginApi.md#recover_password_api_v1_password_recovery_email_post) | **POST** /api/v1/password-recovery/{email} | Recover Password
*LoginApi* | [**reset_password_api_v1_reset_password_post**](docs/LoginApi.md#reset_password_api_v1_reset_password_post) | **POST** /api/v1/reset-password/ | Reset Password
*LoginApi* | [**test_token_api_v1_login_test_token_post**](docs/LoginApi.md#test_token_api_v1_login_test_token_post) | **POST** /api/v1/login/test-token | Test Token
*MistralApi* | [**mistral_get_api_v1_proxy_mistral_path_get**](docs/MistralApi.md#mistral_get_api_v1_proxy_mistral_path_get) | **GET** /api/v1/proxy/mistral/{path} | Mistral Get
*MistralApi* | [**mistral_post_api_v1_proxy_mistral_path_post**](docs/MistralApi.md#mistral_post_api_v1_proxy_mistral_path_post) | **POST** /api/v1/proxy/mistral/{path} | Mistral Post
*OpenaiApi* | [**openai_get_api_v1_proxy_openai_path_get**](docs/OpenaiApi.md#openai_get_api_v1_proxy_openai_path_get) | **GET** /api/v1/proxy/openai/{path} | Openai Get
*OpenaiApi* | [**openai_post_api_v1_proxy_openai_path_post**](docs/OpenaiApi.md#openai_post_api_v1_proxy_openai_path_post) | **POST** /api/v1/proxy/openai/{path} | Openai Post
*SettingsApi* | [**create_setting_api_v1_settings_post**](docs/SettingsApi.md#create_setting_api_v1_settings_post) | **POST** /api/v1/settings | Create Setting
*SettingsApi* | [**read_setting_api_v1_settings_name_get**](docs/SettingsApi.md#read_setting_api_v1_settings_name_get) | **GET** /api/v1/settings/{name} | Read Setting
*UsersApi* | [**create_user_api_v1_users_post**](docs/UsersApi.md#create_user_api_v1_users_post) | **POST** /api/v1/users | Create User
*UsersApi* | [**create_user_open_api_v1_users_open_post**](docs/UsersApi.md#create_user_open_api_v1_users_open_post) | **POST** /api/v1/users/open | Create User Open
*UsersApi* | [**read_user_by_id_api_v1_users_user_id_get**](docs/UsersApi.md#read_user_by_id_api_v1_users_user_id_get) | **GET** /api/v1/users/{user_id} | Read User By Id
*UsersApi* | [**read_user_me_api_v1_users_me_get**](docs/UsersApi.md#read_user_me_api_v1_users_me_get) | **GET** /api/v1/users/me | Read User Me
*UsersApi* | [**read_users_api_v1_users_get**](docs/UsersApi.md#read_users_api_v1_users_get) | **GET** /api/v1/users | Read Users
*UsersApi* | [**update_user_api_v1_users_user_id_put**](docs/UsersApi.md#update_user_api_v1_users_user_id_put) | **PUT** /api/v1/users/{user_id} | Update User
*UsersApi* | [**update_user_me_api_v1_users_me_put**](docs/UsersApi.md#update_user_me_api_v1_users_me_put) | **PUT** /api/v1/users/me | Update User Me
*UtilsApi* | [**test_email_api_v1_utils_test_email_post**](docs/UtilsApi.md#test_email_api_v1_utils_test_email_post) | **POST** /api/v1/utils/test-email | Test Email


## Documentation For Models

 - [BodyCreateUserOpenApiV1UsersOpenPost](docs/BodyCreateUserOpenApiV1UsersOpenPost.md)
 - [BodyResetPasswordApiV1ResetPasswordPost](docs/BodyResetPasswordApiV1ResetPasswordPost.md)
 - [BodyUpdateUserMeApiV1UsersMePut](docs/BodyUpdateUserMeApiV1UsersMePut.md)
 - [ClientId](docs/ClientId.md)
 - [ClientSecret](docs/ClientSecret.md)
 - [Email](docs/Email.md)
 - [Event](docs/Event.md)
 - [EventCreate](docs/EventCreate.md)
 - [FullName](docs/FullName.md)
 - [GrantType](docs/GrantType.md)
 - [HTTPValidationError](docs/HTTPValidationError.md)
 - [Id](docs/Id.md)
 - [IsActive](docs/IsActive.md)
 - [IsSuperuser](docs/IsSuperuser.md)
 - [Msg](docs/Msg.md)
 - [ParentId](docs/ParentId.md)
 - [Password](docs/Password.md)
 - [ResponseReadSettingApiV1SettingsNameGet](docs/ResponseReadSettingApiV1SettingsNameGet.md)
 - [Setting](docs/Setting.md)
 - [SettingCreate](docs/SettingCreate.md)
 - [Timestamp](docs/Timestamp.md)
 - [Token](docs/Token.md)
 - [User](docs/User.md)
 - [UserCreate](docs/UserCreate.md)
 - [UserUpdate](docs/UserUpdate.md)
 - [ValidationError](docs/ValidationError.md)
 - [ValidationErrorLocInner](docs/ValidationErrorLocInner.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="OAuth2PasswordBearer"></a>
### OAuth2PasswordBearer

- **Type**: OAuth
- **Flow**: password
- **Authorization URL**: 
- **Scopes**: N/A


## Author




